package kr.co.iyapp.todayhan.activity;

import androidx.appcompat.app.AppCompatActivity;

import android.annotation.SuppressLint;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.webkit.WebChromeClient;
import android.webkit.WebResourceRequest;
import android.webkit.WebView;
import android.webkit.WebViewClient;

import kr.co.iyapp.todayhan.util.HtmlBridge;
import kr.co.iyapp.todayhan.R;

public class MainActivity extends AppCompatActivity {

    private WebView webView;
    private Context context;

    @SuppressLint("SetJavaScriptEnabled")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        context = this.getApplicationContext();

        // 웹뷰 셋팅
        webView = (WebView) findViewById(R.id.webView);
        webView.getSettings().setJavaScriptEnabled(true); //자바스크립트 허용

        webView.loadUrl("file:///android_asset/html/index.html");
        webView.setWebChromeClient(new WebChromeClient());  // 새창 띄우지 않기
        webView.setWebViewClient(new WevViewClientClass());
        webView.setWebContentsDebuggingEnabled(true);

        webView.addJavascriptInterface(new HtmlBridge(webView, MainActivity.this), "connector");

    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        /*
        if ((keyCode == KeyEvent.KEYCODE_BACK) && webView.canGoBack()) {
            webView.goBack();
            return true;
        }
        return super.onKeyDown(keyCode, event);
                 */

        if (keyCode == KeyEvent.KEYCODE_BACK) {
            /*
            String alertTitle = "종료 안내";
            String buttonMessage = "어플을 종료하시겠습니까?";
            String buttonYes = "Yes";
            String buttonNo = "No";

            new AlertDialog.Builder(MenuActivity.this)
                    .setTitle(alertTitle)
                    .setMessage(buttonMessage)
                    .setPositiveButton(buttonYes, new DialogInterface.OnClickListener() {

                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            // TODO Auto-generated method stub
                            moveTaskToBack(true);
                            finish();
                        }
                    })
                    .setNegativeButton(buttonNo, null)
                    .show();

             */
            webView.loadUrl("javascript:appClose()");
        }
        return true;
    }

    private class WevViewClientClass extends WebViewClient {
        @Override
        public boolean shouldOverrideUrlLoading(WebView view, WebResourceRequest request) {
            String url = String.valueOf(request.getUrl());

            if( url.startsWith("app://") ){  // 현재 uri의 path에 컨테인만 읽기
                Intent intent = new Intent(MainActivity.this, MenuActivity.class); // 새창을 여는 액티비티나, 팝업일때 이용하면 용이합니다.
                intent.putExtra("url",view.getUrl());
                startActivity(intent);
                return true;
            }
            return super.shouldOverrideUrlLoading(view, request);
        }
    }
}