package kr.co.iyapp.todayhan.activity;

import static android.content.Intent.FLAG_ACTIVITY_NEW_TASK;

import androidx.appcompat.app.AppCompatActivity;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.webkit.WebChromeClient;
import android.webkit.WebResourceRequest;
import android.webkit.WebView;
import android.webkit.WebViewClient;

import kr.co.iyapp.todayhan.R;
import kr.co.iyapp.todayhan.util.AppConfig;
import kr.co.iyapp.todayhan.util.HtmlBridge;

public class StudyResultActivity extends AppCompatActivity {

    private WebView webView;
    private Context context;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_study_result);
        context = this.getApplicationContext();

        // 웹뷰 셋팅
        webView = (WebView) findViewById(R.id.webView);
        webView.getSettings().setJavaScriptEnabled(true); //자바스크립트 허용


        webView.setWebChromeClient(new WebChromeClient());  // 새창 띄우지 않기
        webView.setWebViewClient(new WevViewClientClass());
        webView.setWebContentsDebuggingEnabled(true);


        Intent intent = getIntent();
        String selectDate = intent.getStringExtra("selectDate") == null?"": intent.getStringExtra("selectDate");

        ////((AppConfig)getApplication())
        webView.addJavascriptInterface(new HtmlBridge(webView, StudyResultActivity.this, selectDate, ((AppConfig)getApplication()) ), "connector");
        webView.loadUrl("file:///android_asset/html/result.html");
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        Log.d("XXX", "1111XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
        Log.d("XXX"," keyCode > "+keyCode +"   "+KeyEvent.KEYCODE_BACK);
        Log.d("XXX","###########################################################3");

        if ( (keyCode == KeyEvent.KEYCODE_BACK) ) {

            Log.d("XXX", "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
            //webView.goBack();
            finishAffinity();
            Intent intent = new Intent(this.context, MenuActivity.class);
            context.startActivity(intent.addFlags(FLAG_ACTIVITY_NEW_TASK));
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }

    public class WevViewClientClass extends WebViewClient {
        @Override
        public boolean shouldOverrideUrlLoading(WebView view, WebResourceRequest request) {
            String url = String.valueOf(request.getUrl());

            if( url.startsWith("app://menuAcitivity") ){  // 현재 uri의 path에 컨테인만 읽기
                Intent intent = new Intent(StudyResultActivity.this, MainActivity.class); // 새창을 여는 액티비티나, 팝업일때 이용하면 용이합니다.
                intent.putExtra("url",view.getUrl());
                startActivity(intent);
                return true;
            }
            return super.shouldOverrideUrlLoading(view, request);
        }
    }
}