package kr.co.iyapp.todayhan.util;

import android.content.Context;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class DBUtil extends SQLiteOpenHelper {

    private static String DB_PATH = "";
    private static final String DB_NAME = "studyhanja.db";

    private SQLiteDatabase sqliteDb;
    private Context context;

    public DBUtil(Context context) {
        super(context,DB_NAME,null,1);
        DB_PATH = "/data/data/" + context.getPackageName() + "/databases/";
        this.context = context;
        dataBaseCheck();
    }

    private void dataBaseCheck() {
        File dbFile = new File(DB_PATH + DB_NAME);
        Log.d("dataBaseCheck",DB_PATH + DB_NAME);
        if (!dbFile.exists()) {
            dbCopy();
            Log.d("dataBaseCheck","Database is copied.");
        }
    }

    // db를 assets에서 복사해온다.
    private void dbCopy() {
        Log.d("dbCopy","Database Copy Start..");
        try {
            File folder = new File(DB_PATH);
            if (!folder.exists()) {
                folder.mkdir();
            }

            InputStream inputStream = context.getAssets().open(DB_NAME);

            String outFileNm = DB_PATH + DB_NAME;
            OutputStream outputStream = new FileOutputStream(outFileNm);

            byte[] mBuffer = new byte[1024];
            int mLength;
            while ((mLength = inputStream.read(mBuffer)) > 0) {
                outputStream.write(mBuffer,0,mLength);
            }

            outputStream.flush();;
            outputStream.close();
            inputStream.close();

        } catch (IOException e) {
            e.printStackTrace();
            Log.d("dbCopy", "IOException 발생함");
        }
    }

    //데이터베이스를 열어서 쿼리를 쓸수있게만든다.
    public SQLiteDatabase connetion() throws SQLException {
        String mPath = DB_PATH + DB_NAME;
        Log.d("mPath", mPath);
        sqliteDb = SQLiteDatabase.openDatabase(mPath, null, SQLiteDatabase.CREATE_IF_NECESSARY);
        return sqliteDb;
    }


    // db를 assets에서 복사해온다.
    public String  dbInit() {
        Log.d("dbInit","Database Init Start..");

        String returnMsg = "데이터 초기화에 실패하였습니다.";

        String delFile = DB_PATH + DB_NAME;
        File file = new File(delFile);
        boolean delGbn =  file.delete();
        if(delGbn){
            returnMsg ="모든 데이터가 초기화 되었습니다.";
        }else{
            dbCopy();
        }
        return returnMsg;
    }


    @Override
    public synchronized void close() {
        if (sqliteDb != null) {
            sqliteDb.close();
        }
        super.close();
    }

    @Override
    public void onCreate(SQLiteDatabase sqLiteDatabase) {

    }

    @Override
    public void onUpgrade(SQLiteDatabase sqLiteDatabase, int i, int i1) {

    }

}
