package kr.co.iyapp.todayhan.util;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.speech.tts.TextToSpeech;
import android.util.Log;
import android.webkit.JavascriptInterface;
import android.webkit.WebView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import kr.co.iyapp.todayhan.activity.ConfigActivity;
import kr.co.iyapp.todayhan.activity.HistoryActivity;
import kr.co.iyapp.todayhan.activity.MenuActivity;
import kr.co.iyapp.todayhan.activity.RestudyActivity;
import kr.co.iyapp.todayhan.activity.StudyActivity;
import kr.co.iyapp.todayhan.activity.StudyResultActivity;
import kr.co.iyapp.todayhan.activity.TestActivity;
import kr.co.iyapp.todayhan.dao.TodayHanjaDAO;

public class HtmlBridge<context> {
    private String TAG = "HtmlBridge";
    private WebView webView;
    private TodayHanjaDAO da;
    private JSONArray config;
    private Handler handler = new Handler();
    private TextToSpeech tts;
    private Context context;
    private JSONArray list;
    private String selectDate;
    private String actName;
    private Toast mToast;
    private AppConfig appConfig;

    public HtmlBridge(WebView webView, Context context ){
        this.da = new TodayHanjaDAO(context);
        this.webView = webView;
        this.context = context;
        this.actName = context.getClass().getName();
        this.config  = getConfig();
        Log.i("ActivityName >>>>> ", context.getClass().getName());
        mToast = Toast.makeText( context, "", Toast.LENGTH_SHORT);
    }

    public HtmlBridge(WebView webView, Context context , String selectDate){
        this.da = new TodayHanjaDAO(context);
        this.webView = webView;
        this.context = context;
        this.selectDate = selectDate;
        this.actName = context.getClass().getName();
        this.config  = getConfig();
        Log.i("ActivityName >>>>> ", context.getClass().getName());
    }

    public HtmlBridge(WebView webView, Context context,  TextToSpeech tts,  String selectDate){
        this.da = new TodayHanjaDAO(context);
        this.webView = webView;
        this.tts     = tts;
        this.context = context;
        this.selectDate = selectDate;
        this.actName = context.getClass().getName();
        this.config  = getConfig();
        Log.i("ActivityName >>>>> ", context.getClass().getName()   );
    }

    public HtmlBridge(WebView webView, Context context,  TextToSpeech tts,  String selectDate, AppConfig appConfig){
        this.da = new TodayHanjaDAO(context);
        this.webView = webView;
        this.tts     = tts;
        this.context = context;
        this.selectDate = selectDate;
        this.actName = context.getClass().getName();
        this.config  = getConfig();
        this.appConfig = appConfig;
        Log.i("ActivityName >>>>> ", context.getClass().getName()   );
    }

    public HtmlBridge(WebView webView, Context context, String selectDate, AppConfig appConfig) {
        this.da = new TodayHanjaDAO(context);
        this.webView = webView;
        this.context = context;
        this.selectDate = selectDate;
        this.actName = context.getClass().getName();
        this.config  = getConfig();
        this.appConfig = appConfig;
    }

    @JavascriptInterface
    public void getSelectDate() {
        String selDate = this.selectDate==null?"":this.selectDate;
        //Log.d( TAG , "selDate >>>> "+selDate);
        handler.post(new Runnable() {
            public void run() {
                webView.loadUrl("javascript:setSelectDate('"+selDate+"')");
            }
        });
    }

    @JavascriptInterface
    public void getAppConfig() {
        JSONArray list = this.config;
        handler.post(new Runnable() {
            public void run() {
                webView.loadUrl("javascript:setAppConfig("+list+")");
            }
        });
    }

    @JavascriptInterface
    public void getWordContent(String todayGbn) {
        JSONArray list = da.getStudyContent(todayGbn, "");
        //Log.d( TAG , list.toString());
        handler.post(new Runnable() {
            public void run() {
                webView.loadUrl("javascript:setWordContent("+list+")");
            }
        });
    }



    @JavascriptInterface
    public void getWordContent(String todayGbn, String correctGbn ) {
        JSONArray list = da.getStudyContent("today", "");
        //Log.d( TAG , list.toString());
        handler.post(new Runnable() {
            public void run() {
                webView.loadUrl("javascript:setWordContent("+list+")");
            }
        });
    }


    @JavascriptInterface
    public void getReWordContent(String todayGbn) {
        JSONArray list = da.getStudyContent(todayGbn, "renew");
        //Log.d( TAG , list.toString());
        handler.post(new Runnable() {
            public void run() {
                webView.loadUrl("javascript:setWordContent("+list+")");
            }
        });
    }

    @JavascriptInterface
    public void getTestExample(String date , String wordId) {
        JSONArray list = da.getTestExample(date , wordId);
        //Log.d( TAG , list.toString());
        handler.post(new Runnable() {
            public void run() {
                webView.loadUrl("javascript:setTestExam("+list+")");
            }
        });
    }


    @JavascriptInterface
    public void getStudyDayContent(String date ) {
        JSONArray list = da.getStudyContent(date);
        //Log.d( TAG , list.toString());
        handler.post(new Runnable() {
            public void run() {
                webView.loadUrl("javascript:setWordContent("+list+")");
            }
        });
    }

    @JavascriptInterface
    public void getTestResult(String date) {
        JSONArray list = da.getTestResult(date);
        //Log.d( TAG , list.toString());
        handler.post(new Runnable() {
            public void run() {
                webView.loadUrl("javascript:setWordContent("+list+")");
            }
        });
    }

    @JavascriptInterface
    public void readText(String text , String id) {
        tts.speak(text, TextToSpeech.QUEUE_FLUSH ,null, id );
    }

    @JavascriptInterface
    public void updateIncorrect(String correctGbn , String wordId) {
         //Log.d("HtmlBridge","=-=-=- wordId : "+wordId+" =-=-=-");
         da.updateIncorrect(correctGbn , wordId);
    }

    @JavascriptInterface
    public void setConfig(String label, String keys , String value) {
        //Log.d("HtmlBridge","=-=-=-=-=-=-=- "+keys+"  ,  "+value+" =-=-=-=-=-=-=-");
        if(keys.equals("dayCnt")){
            da.updateRemoveStudyDay();
            da.deleteRemoveStudyDayMaster();
        }

       int result =  da.updateConfig(keys , value);
       if(result > 0){
           if(keys.equals("dayCnt")){
               //Toast.makeText( context,  label+"["+value+"]이(가) 저장되었고,\n금일 데이터가 초기화 되었습니다.", Toast.LENGTH_LONG).show();
               mToast.cancel();
               mToast.setText(label+"["+value+"]이(가) 저장되었고,\n금일 데이터가 초기화 되었습니다.");
               mToast.show();

           }else{
               //Toast.makeText( context,  label+"["+value+"]이(가) 저장되었습니다.", Toast.LENGTH_LONG).show();
               mToast.cancel();
               mToast.setText(label+"["+value+"]이(가) 저장되었습니다.");
               mToast.show();
           }

       }
    }

    @JavascriptInterface
    public void dbInit() {
        String returnMsg ="";
        DBUtil dbutil = new DBUtil(context);
        returnMsg = dbutil.dbInit();
       // Toast.makeText( context,  returnMsg , Toast.LENGTH_LONG).show();
        mToast.cancel();
        mToast.setText(returnMsg);
        mToast.show();

    }


    @JavascriptInterface
    public void goToConfigPage() {
        //Toast.makeText( context, "settings in ...", Toast.LENGTH_LONG).show();
        Intent intent = new Intent(this.context, ConfigActivity.class);
        context.startActivity(intent);
//        Activity act = (Activity) this.context;
//        act.finish();
    }
    @JavascriptInterface
    public void goToTestPage() {
        //Toast.makeText( context, "settings in ...", Toast.LENGTH_LONG).show();
        Intent intent = new Intent(this.context, TestActivity.class);
        context.startActivity(intent);
//        Activity act = (Activity) this.context;
//        act.finish();
    }
    @JavascriptInterface
    public void goToReverseTestPage(String selectDate) {
        //Toast.makeText( context, "settings in ...", Toast.LENGTH_LONG).show();

        Intent intent = new Intent(this.context, TestActivity.class);
        intent.putExtra("selectDate", selectDate);

        this.appConfig.setReverseGbn("Y"); //거꾸로 테스트
                
        context.startActivity(intent);
//        Activity act = (Activity) this.context;
//        act.finish();
    }
    @JavascriptInterface
    public void goToTestPage(String selectDate) {
        //Toast.makeText( context, "settings in ...", Toast.LENGTH_LONG).show();
        //Log.e( TAG , "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"+selectDate);
        Intent intent = new Intent(this.context, TestActivity.class);
        intent.putExtra("selectDate", selectDate);
        context.startActivity(intent);
//        Activity act = (Activity) this.context;
//        act.finish();
    }
    @JavascriptInterface
    public void goToMenuPage() {
        //Toast.makeText( context, "settings in ...", Toast.LENGTH_LONG).show();
        Intent intent = new Intent(this.context, MenuActivity.class);
        context.startActivity(intent);
        Activity act = (Activity) this.context;
        act.finish();
    }
    @JavascriptInterface
    public void goToStudyPage() {
        //Toast.makeText( context, "settings in ...", Toast.LENGTH_LONG).show();
        Intent intent = new Intent(this.context, StudyActivity.class);
        context.startActivity(intent);
//        Activity act = (Activity) this.context;
//        act.finish();
    }
    @JavascriptInterface
    public void goToRestudyPage() {
        //Toast.makeText( context, "settings in ...", Toast.LENGTH_LONG).show();
        Intent intent = new Intent(this.context, RestudyActivity.class);
        context.startActivity(intent);
//        Activity act = (Activity) this.context;
//        act.finish();
    }
    @JavascriptInterface
    public void goToRestudyPage(String selectDate) {
        //Toast.makeText( context, "settings in ...", Toast.LENGTH_LONG).show();
        Intent intent = new Intent(this.context, RestudyActivity.class);
        intent.putExtra("selectDate" ,  selectDate);
        intent.putExtra("studyGbn"   , "reStudy");
        context.startActivity(intent);
//        Activity act = (Activity) this.context;
//        act.finish();
    }
    @JavascriptInterface
    public void goToStudyResultPage() {
        //Toast.makeText( context, "settings in ...", Toast.LENGTH_LONG).show();
        Intent intent = new Intent(this.context, StudyResultActivity.class);
        context.startActivity(intent);
//        Activity act = (Activity) this.context;
//        act.finish();
    }

    @JavascriptInterface
    public void goToStudyResultPage(String selectDate) {
        //Toast.makeText( context, "settings in ...", Toast.LENGTH_LONG).show();
        //Log.e( TAG , "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"+selectDate);
        Intent intent = new Intent(this.context, StudyResultActivity.class);
        intent.putExtra("selectDate", selectDate);
        context.startActivity(intent);
//        Activity act = (Activity) this.context;
//        act.finish();
    }

    @JavascriptInterface
    public void goToHistoryPage() {
        //Toast.makeText( context, "settings in ...", Toast.LENGTH_LONG).show();
        Intent intent = new Intent(this.context, HistoryActivity.class);
        context.startActivity(intent);
//        Activity act = (Activity) this.context;
//        act.finish();
    }

    @JavascriptInterface
    public void goToHistoryStudy(String selectDate) {
        //Toast.makeText( context, "settings in ...", Toast.LENGTH_LONG).show();
        //Log.e( TAG , "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"+selectDate);
        Intent intent = new Intent(this.context, StudyActivity.class);
        intent.putExtra("selectDate", selectDate);
        context.startActivity(intent);
//        Activity act = (Activity) this.context;
//        act.finish();
    }

    private JSONArray getConfig(){
        JSONArray list= new JSONArray();
        String actNm = this.actName;
        if(actNm.indexOf("Config") > 0){
            list = da.getAppConfig("config");
        }

        if(actNm.indexOf("StudyActivity") > 0 || actNm.indexOf("RestudyActivity") > 0 ){
            list = da.getAppConfig("study");
        }
        return list;

    }

    @JavascriptInterface
    public void getConfigJson(){
        JSONArray config= this.config;
        JSONObject json = new JSONObject();

        for(int i=0;i<config.length();i++){
            try {
                JSONObject temp = config.getJSONObject(i);
                json.put((String) temp.get("keys"), temp.get("value"));
            }catch(JSONException e){
                Log.e(TAG, e.getMessage());
            }

        }
        JSONObject finalJson = json;
        handler.post(new Runnable() {
            public void run() {
                webView.loadUrl("javascript:setConfigJson("+ finalJson +")");
            }
        });
    }

    @JavascriptInterface
    public void getStudyResult(){
        JSONObject obj = da.getStudyResult();
        //Log.d( TAG , obj.toString());
        handler.post(new Runnable() {
            public void run() {
                webView.loadUrl("javascript:setStudyResult("+obj+")");
            }
        });
    }

    @JavascriptInterface
    public void getActName(){
        String actNm = this.actName;
        handler.post(new Runnable() {
            public void run() {
                webView.loadUrl("javascript:setActName('"+actNm+"')");
            }
        });
    }


    @JavascriptInterface
    public void getStudyCount(){
        String count = da.getStudyCount();
        handler.post(new Runnable() {
            public void run() {
                webView.loadUrl("javascript:setStudyCount('"+count+"')");
            }
        });
    }
    @JavascriptInterface
    public void getStudyDayMaster(String date){
        JSONObject json = da.getStudyDayMaster(date);
        handler.post(new Runnable() {
            public void run() {
                webView.loadUrl("javascript:Util.setPageData("+json+")");
            }
        });
    }

    private void initTTS() {
        //Log.d(TAG , "tts...................."+tts.toString());
    }

    @JavascriptInterface
    public void updateReviewActGbn(String selDate , String reviewActGbn) {
        //Log.d("HtmlBridge","=-=-=- wordId : "+wordId+" =-=-=-");
        da.mergeDayMaster(selDate, reviewActGbn);
    }

    @JavascriptInterface
    public void popToast(String msg) {
       mToast.cancel();
       mToast.setText(msg);
       mToast.show();
    }
    @JavascriptInterface
    public void insertDayPoint(String selDate , String point) {
        da.insertDayPoint(selDate, point);
    }

    @JavascriptInterface
    public void getReverseGbn(){
        String reverseGbn = this.appConfig.getReverseGbn();
        handler.post(new Runnable() {
            public void run() {
                webView.loadUrl("javascript:Util.setReverseGbn('"+reverseGbn+"')");
            }
        });
    }


    @JavascriptInterface
    public void getStduayPoint(String date) {
        JSONArray list = da.getStudyDayPoint(date);
        //Log.d( TAG , list.toString());
        handler.post(new Runnable() {
            public void run() {
                webView.loadUrl("javascript:setStduayPoint("+list+")");
            }
        });
    }
}


